#
# spec file for package ghc-th-expand-syns
#
# Copyright (c) 2021 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name th-expand-syns
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.4.9.0
Release:        bp155.2.16
Summary:        Expands type synonyms in Template Haskell ASTs
License:        BSD-3-Clause
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-syb-devel
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-th-abstraction-devel
ExcludeArch:    %{ix86}

%description
Expands type synonyms in Template Haskell ASTs.

As of version '0.4.9.0', this library is a small shim on top of the
'applySubstitution'/'resolveTypeSynonyms' functions from 'th-abstraction', so
you may want to consider using 'th-abstraction' instead.

%package devel
Summary:        Haskell %{pkg_name} library development files
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%autosetup -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc changelog.markdown

%changelog
* Fri Sep  3 2021 psimons@suse.com
- Update th-expand-syns to version 0.4.9.0.
  [#]# 0.4.9.0 [2021.08.30]
  * Consolidate the type-synonym expansion functionality with `th-abstraction`,
    which also provides the ability to expand type synonyms. After this change,
    the `th-expand-syns` library is mostly a small shim on top of
    `th-abstraction`. The only additional pieces of functionality that
    `th-expand-syns` which aren't currently available in `th-abstraction` are:
  * `th-expand-syns`' `expandSyns{With}` functions will warn that they cannot
    expand type families (if the `SynonymExpansionSettings` are configured to
    check for this). By contrast, `th-abstraction`'s `applySubstitution`
    function will silently ignore type families.
  * `th-expand-syns` provides a `substInCon` function which allows substitution
    into `Con`s.
  * `th-expand-syns` provides `evade{s}` functions which support type variable
    `Name` freshening that calculating the free variables in any type that
    provides an instance of `Data`.
* Fri Mar 12 2021 psimons@suse.com
- Update th-expand-syns to version 0.4.8.0.
  [#]# 0.4.8.0 [2021.03.12]
  * Make the test suite compile with GHC 9.0 or later.
  * Drop support for pre-7.0 versions of GHC.
  [#]# 0.4.7.0
  * Support GHC 9.0 / template-haskell-2.17 (Thanks to @mgsloan)
* Thu Dec 17 2020 Ondřej Súkup <mimi.vx@gmail.com>
- disable %%{ix86} build
* Fri Sep  4 2020 Peter Simons <psimons@suse.com>
- Replace %%setup -q with the more modern %%autosetup macro.
* Wed Apr  1 2020 psimons@suse.com
- Update th-expand-syns to version 0.4.6.0.
  Upstream has not updated the file "changelog.markdown" since the
  last release.
* Fri Nov  8 2019 Peter Simons <psimons@suse.com>
- Drop obsolete group attributes.
* Fri Aug 30 2019 psimons@suse.com
- Update th-expand-syns to version 0.4.5.0.
  [#]# 0.4.5.0
  * Support GHC 8.8 / template-haskell-2.15 (Thanks to Ryan Scott)
  * Support GHC 8.6 / template-haskell-2.14 (Thanks to Chaitanya Koparkar)
* Fri Oct 19 2018 Peter Simons <psimons@suse.com>
- Update Cabal build instructions to support ghc-8.6.1.
* Wed Jul 18 2018 psimons@suse.com
- Cosmetic: replace tabs with blanks, strip trailing white space,
  and update copyright headers with spec-cleaner.
* Mon May 14 2018 psimons@suse.com
- Update th-expand-syns to version 0.4.4.0.
  * Made `SynonymExpansionSettings` an instance of `Semigroup`
    (fixes build with GHC 8.4.1 alpha).
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Mon Apr 24 2017 psimons@suse.com
- Update to version 0.4.3.0 with cabal2obs.
* Wed Jan 18 2017 psimons@suse.com
- Update to version 0.4.2.0 with cabal2obs.
* Mon Nov 14 2016 psimons@suse.com
- Update to version 0.4.1.0 with cabal2obs.
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.4.0.0 revision 0 with cabal2obs.
